﻿namespace QQZhaoCha
{
    using System;
    using System.ComponentModel;
    using System.Drawing;
    using System.Drawing.Drawing2D;
    using System.Windows.Forms;

    public class SelectScreen : Form
    {
        public Bitmap bmpScreen;
        private bool boolMousePress;
        private bool boolSelectBoxShowed;
        private bool boolSelected;
        private bool boolShowSelectBox;
        private IContainer components;
        private Graphics gScreen;
        private Image imgNewScreen;
        private Image imgScreen;
        public int intMinOffSet;
        public int intX1;
        public int intX2;
        public int intY1;
        public int intY2;
        private Label lblNotes1;
        private Label lblNotes2;
        private Bitmap newImg;
        private Pen penSelectBox1 = new Pen(Brushes.Blue);
        private Pen penSelectBox2 = new Pen(Brushes.DarkBlue);
        private Rectangle recSelectBox = new Rectangle();
        public Image showImg;

        public SelectScreen()
        {
            this.InitializeComponent();
        }

        private void ClearSelectBox()
        {
            Image image = (Image) this.imgScreen.Clone();
            this.gScreen.DrawImage(image, 0, 0);
            this.boolSelectBoxShowed = false;
        }

        private int ComparePic(int intOffSet)
        {
            this.newImg = new Bitmap(380, 0x11d);
            int num = 0;
            for (int i = this.intX1; i < (this.intX1 + 380); i++)
            {
                for (int j = this.intY1; j < (this.intY1 + 0x11d); j++)
                {
                    if (this.InSelectBox(new Point(i, j)) && (j != this.intY2))
                    {
                        Color pixel = this.bmpScreen.GetPixel(i, j);
                        Color color2 = this.bmpScreen.GetPixel((i + 0x189) + intOffSet, j);
                        if (pixel != color2)
                        {
                            num++;
                            this.newImg.SetPixel(i - this.intX1, j - this.intY1, Color.Black);
                        }
                    }
                    if (num > 0xc350)
                    {
                        break;
                    }
                }
                if (num > 0xc350)
                {
                    return num;
                }
            }
            return num;
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.lblNotes1 = new Label();
            this.lblNotes2 = new Label();
            base.SuspendLayout();
            this.lblNotes1.AutoSize = true;
            this.lblNotes1.BackColor = Color.White;
            this.lblNotes1.Font = new Font("SimHei", 18f, FontStyle.Regular, GraphicsUnit.Point, 0x86);
            this.lblNotes1.Location = new Point(0x49, 0x4c);
            this.lblNotes1.Name = "lblNotes1";
            this.lblNotes1.Size = new Size(0x15a, 0x18);
            this.lblNotes1.TabIndex = 0;
            this.lblNotes1.Text = "框选图片，双击选框内开始找茬";
            this.lblNotes2.AutoSize = true;
            this.lblNotes2.BackColor = Color.White;
            this.lblNotes2.Font = new Font("SimHei", 18f, FontStyle.Regular, GraphicsUnit.Point, 0x86);
            this.lblNotes2.Location = new Point(0x49, 110);
            this.lblNotes2.Name = "lblNotes2";
            this.lblNotes2.Size = new Size(0x1a2, 0x18);
            this.lblNotes2.TabIndex = 1;
            this.lblNotes2.Text = "按ESC退出,或按右键1次取消，2次退出";
            base.AutoScaleDimensions = new SizeF(6f, 12f);
            base.AutoScaleMode = AutoScaleMode.Font;
            base.ClientSize = new Size(0x267, 0x16b);
            base.Controls.Add(this.lblNotes2);
            base.Controls.Add(this.lblNotes1);
            this.ForeColor = Color.Red;
            base.FormBorderStyle = FormBorderStyle.None;
            base.Name = "SelectScreen";
            this.Text = "SelectScreen";
            base.WindowState = FormWindowState.Maximized;
            base.Load += new EventHandler(this.SelectScreen_Load);
            base.MouseUp += new MouseEventHandler(this.SelectScreen_MouseUp);
            base.MouseDoubleClick += new MouseEventHandler(this.SelectScreen_MouseDoubleClick);
            base.MouseDown += new MouseEventHandler(this.SelectScreen_MouseDown);
            base.KeyPress += new KeyPressEventHandler(this.SelectScreen_KeyPress);
            base.MouseMove += new MouseEventHandler(this.SelectScreen_MouseMove);
            base.ResumeLayout(false);
            base.PerformLayout();
        }

        public bool InSelectBox(Point pointMouse)
        {
            bool flag = false;
            if (((pointMouse.X >= this.intX1) && (pointMouse.X <= this.intX2)) && ((pointMouse.Y >= this.intY1) && (pointMouse.Y <= this.intY2)))
            {
                flag = true;
            }
            return flag;
        }

        private bool OnSelectBox(Point pointMouse)
        {
            return false;
        }

        private void SelectScreen_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (char.ConvertToUtf32(e.KeyChar.ToString(), 0) == 0x1b)
            {
                base.Close();
            }
        }

        private void SelectScreen_Load(object sender, EventArgs e)
        {
            this.imgScreen = this.BackgroundImage;
            this.gScreen = base.CreateGraphics();
        }

        private void SelectScreen_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (((e.Button == MouseButtons.Left) && this.boolSelectBoxShowed) && this.InSelectBox(new Point(e.X, e.Y)))
            {
                base.WindowState = FormWindowState.Minimized;
                int width = this.imgScreen.Width;
                int height = this.imgScreen.Height;
                this.bmpScreen = new Bitmap(this.imgNewScreen);
                int num = 0x186a0;
                int num2 = this.ComparePic(0);
                if (num2 > 0xc350)
                {
                    num2 = this.ComparePic(1);
                    if (num2 < num)
                    {
                        this.intMinOffSet = 1;
                        num = num2;
                    }
                }
                if (num2 > 0xc350)
                {
                    num2 = this.ComparePic(2);
                    if (num2 < num)
                    {
                        this.intMinOffSet = 2;
                        num = num2;
                    }
                }
                if (num2 > 0xc350)
                {
                    num2 = this.ComparePic(3);
                    if (num2 < num)
                    {
                        this.intMinOffSet = 3;
                        num = num2;
                    }
                }
                if (num2 > 0xc350)
                {
                    num2 = this.ComparePic(-1);
                    if (num2 < num)
                    {
                        this.intMinOffSet = -1;
                        num = num2;
                    }
                }
                if (num2 > 0xc350)
                {
                    num2 = this.ComparePic(-2);
                    if (num2 < num)
                    {
                        this.intMinOffSet = -2;
                        num = num2;
                    }
                }
                if (num2 > 0xc350)
                {
                    num2 = this.ComparePic(-3);
                    if (num2 < num)
                    {
                        this.intMinOffSet = -3;
                        num = num2;
                    }
                }
                this.showImg = new Bitmap(0x98, 0x72);
                Graphics graphics = Graphics.FromImage(this.showImg);
                graphics.InterpolationMode = InterpolationMode.High;
                graphics.SmoothingMode = SmoothingMode.HighQuality;
                graphics.Clear(Color.White);
                graphics.DrawImage(this.newImg, new Rectangle(0, 0, this.showImg.Width, this.showImg.Height), new Rectangle(0, 0, 380, 0x11d), GraphicsUnit.Pixel);
                this.boolSelected = true;
                base.Close();
            }
        }

        private void SelectScreen_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                if (!this.boolSelectBoxShowed)
                {
                    this.boolMousePress = true;
                    this.intX1 = e.X;
                    this.intY1 = e.Y;
                    this.intX2 = this.intX1 + 380;
                    this.intY2 = this.intY1 + 0x11d;
                }
                else
                {
                    this.InSelectBox(new Point(e.X, e.Y));
                }
            }
            if (e.Button == MouseButtons.Right)
            {
                if (this.boolSelectBoxShowed)
                {
                    this.ClearSelectBox();
                }
                else
                {
                    base.Close();
                }
            }
        }

        private void SelectScreen_MouseMove(object sender, MouseEventArgs e)
        {
        }

        private void SelectScreen_MouseUp(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                this.boolMousePress = false;
                if (!this.boolSelectBoxShowed)
                {
                    this.ShowSelectBox();
                }
            }
        }

        private void ShowSelectBox()
        {
            this.boolShowSelectBox = true;
            if (!this.boolSelected)
            {
                int width = this.intX2 - this.intX1;
                int height = this.intY2 - this.intY1;
                this.recSelectBox.Size = new Size(width, height);
                this.imgNewScreen = (Image) this.imgScreen.Clone();
                Graphics graphics = Graphics.FromImage(this.imgNewScreen);
                graphics.DrawRectangle(this.penSelectBox1, this.intX1, this.intY1, this.recSelectBox.Width, this.recSelectBox.Height);
                graphics.DrawRectangle(this.penSelectBox2, this.intX1 + 0x188, this.intY1, this.recSelectBox.Width, this.recSelectBox.Height);
                this.gScreen.DrawImage(this.imgNewScreen, 0, 0);
                this.boolShowSelectBox = false;
            }
            this.boolSelectBoxShowed = true;
        }
    }
}

